import cv2
import numpy as np

threshold = 0
def updateThreshold( *args ):
    global threshold
    threshold = max(args[0],1)

cv2.namedWindow("Edges")
cv2.createTrackbar("threshold", "Edges", threshold, 255, updateThreshold)
 
frame = cv2.imread("../lena.jpg",cv2.IMREAD_COLOR)

frame = cv2.cvtColor(frame,cv2.COLOR_BGR2GRAY) 

cv2.imshow("Edges",frame)
cv2.waitKey(0)

frame = cv2.blur(frame,(5,5))

dx = cv2.Sobel(frame, cv2.CV_32F, 0, 1, -1)
dy = cv2.Sobel(frame, cv2.CV_32F, 1, 0, -1)
float_edges = cv2.addWeighted(np.abs(dx), 0.5, np.abs(dy), 0.5, 0)
#float_edges,slope = cv2.cartToPolar(dx,dy)
print(np.max(float_edges))
_, gray_edges = cv2.threshold(float_edges,255,255,cv2.THRESH_TRUNC)
gray_edges = np.asarray(gray_edges,np.uint8)
#gray_edges = gray_edges.astype(np.uint8)

cv2.imshow("Edges",cv2.normalize(dx, None, alpha=0, beta=255, norm_type=cv2.NORM_MINMAX, dtype=cv2.CV_8U))
cv2.waitKey(0)
cv2.imshow("Edges",cv2.normalize(dy, None, alpha=0, beta=255, norm_type=cv2.NORM_MINMAX, dtype=cv2.CV_8U))
cv2.waitKey(0)
cv2.imshow("Edges",gray_edges) # magnitude
cv2.waitKey(0)
try:
    cv2.imshow("Edges",cv2.normalize(slope, None, alpha=0, beta=255, norm_type=cv2.NORM_MINMAX, dtype=cv2.CV_8U)) # slope
    cv2.waitKey(0)
except NameError:
    pass

last = -1
while True:
    if last != threshold:
        last = threshold

        _, binary_edges = cv2.threshold(gray_edges,threshold,255,cv2.THRESH_BINARY)

        cv2.imshow("Edges",binary_edges)
        
    if cv2.waitKey(10) == 27:
        break
    
cv2.destroyAllWindows()
