#include "opencv2/opencv.hpp"
#include <vector>
#include <string>
#include <iostream>

int main (int argc, char *argv[])
{
    cv::namedWindow("Edges", 0);
    int threshold = 0;
    int last = -1;
    cv::createTrackbar("threshold", "Edges", &threshold, 255, NULL);

    cv::Mat frame = cv::imread("../lena.jpg",cv::IMREAD_COLOR), edges;
    if (frame.empty()) return -1;

    cv::cvtColor(frame,frame,cv::COLOR_BGR2GRAY);

    cv::blur(frame,frame,cv::Size(5,5));

    for (;;) {
        if (threshold != last) {
            last = threshold;

            cv::Canny(frame,edges,std::max(threshold/2,1),threshold);

            cv::imshow("Edges",edges);
        }

		int key = cv::waitKey(10);
		if (key == 27) break;
	}
	return 0;
}
