import cv2
import numpy as np

threshold = 300
def updateThreshold( *args ):
    global threshold
    threshold = max(args[0],1)

cv2.namedWindow("Edges")
cv2.createTrackbar("threshold", "Edges", threshold, 512, updateThreshold)
 
frame = cv2.imread("../lena.jpg",cv2.IMREAD_COLOR)
 
frame = cv2.cvtColor(frame,cv2.COLOR_BGR2GRAY)

frame = cv2.blur(frame,(5,5))

last = -1
while True:
    if last != threshold:
        last = threshold

        edges = cv2.Canny(frame,max(1,threshold//2), threshold, False)

        cv2.imshow("Edges",edges)
        
    if cv2.waitKey(10) == 27:
        break
    
cv2.destroyAllWindows()
